Require CoqAddOn.
Require Import CertC.
Require PolC.
Require PolLinZ.
Require Import Debugging.
Require PolZ.

Require Import ExtrOcamlString.

Set Extraction AccessOpaque.



(** Debugging 
in order to debug, you need to:
  - comment the normal "mode"
  - decomment the debugging "mode" 
*)
(* begin: normal mode *) 
(* Extraction Inline failwith. *)
(* Extraction Inline trace. *)
(* end: normal mode *)

(* begin: debugging code *)
Extract Inlined Constant failwith =>
   "(fun l _ -> failwith (CoqPr.charListTr l))".

(* If needed, change the global mode below in the first arg of [trace_cmp]. *)
Extract Inlined Constant trace =>
   "(fun mode l a -> if (Debugging.traceCmp INFO mode) then (print_string (CoqPr.charListTr l); print_newline()); a)".
(* end: debugging code *)


Extract Inlined Constant Cert.id_t => "int".
Extract Inlined Constant Cert.eqId => "(=)".
Extract Inlined Constant Cert.shift => "(+)".
Extract Inlined Constant Cert.idPr => "(fun i -> CoqPr.stringTr (string_of_int i))".

Extract Inlined Constant CoqAddOn.posPr => "CoqPr.posPr'".
Extract Inlined Constant CoqAddOn.posPrRaw => "CoqPr.posPrRaw'".
Extract Inlined Constant CoqAddOn.zPr => "CoqPr.zPr'".
Extract Inlined Constant CoqAddOn.zPrRaw => "CoqPr.zPrRaw'".

Extract Inlined Constant Shadow.t => "Pol.t".
Extract Inlined Constant Shadow.pr => "(fun p -> CoqPr.stringTr (Pol.prExtRaw p))".
Extract Inlined Constant Shadow.getId => "Pol.get_nxt".
Extract Inlined Constant Shadow.top => "Pol.top".
Extract Inlined Constant Shadow.isIncl => "Support.isIncl".
Extract Inlined Constant Shadow.add => "Support.add".
Extract Inlined Constant Shadow.addp => "Support.addp".
Extract Inlined Constant Shadow.meet => "Support.meet".
Extract Inlined Constant Shadow.join => "Support.join".
Extract Inlined Constant Shadow.widen => "Support.widen".
Extract Inlined Constant Shadow.getItv => "Support.getItv".
Extract Inlined Constant Shadow.project => "Support.project".
Extract Inlined Constant Shadow.rename => "Support.rename".

Extract Inductive bool => "bool" [ "true" "false" ].
Extract Inductive sumbool => "bool" [ "true" "false" ].
Extract Inductive option => "option" [ "Some" "None" ].
Extract Inductive unit => "unit" [ "()" ].
Extract Inductive list => "list" [ "[]" "(::)" ].
Extract Inductive prod => "(*)" [ "(,)" ].

Extraction Blacklist List String.

(* Extraction Language Fsharp. *)
Extraction Inline value error.
Separate Extraction Debugging PolC PolLinZ PolZ
 (* for compatibility with vpl/lib: *) Shadow Itv.
