Require Import String.
Require Import NumC.
Require Import ProgVar.
Require Import LinTerm.
Require Import CstrC.
Require Import CertC.
Require Import ConsSet.

Axiom t: Set.

Inductive inclT: Type :=
| NotIncl
| Incl: Cert.t -> inclT.

Inductive bndT: Set
:=
  | Infty: bndT
  | Open: QNum.t -> Cert.frag_t -> bndT
  | Closed: QNum.t -> Cert.frag_t -> bndT.

Record itvT: Set
:= mk {
       low: bndT;
       up: bndT
}.

Inductive addPrecT: Set
  := Added: t -> Cert.t * Cert.t -> addPrecT
   | Contrad: Cert.t -> addPrecT.

(*
Record assignT: Type
  := mkAssign {
         var: PVar.t;
         lin: Lin.t;
         cst: QNum.t
       }.
*)

Axiom getId: t -> Cert.id_t.
Axiom top: t.
Axiom isIncl: t -> t -> inclT.
Axiom add: t -> Cstr.t -> option t * Cert.t.
Axiom addp: t -> Cstr.t -> addPrecT.
Axiom meet: t -> t -> option t * Cert.meetT.
Axiom join: t -> t -> t * Cert.joinT.
Axiom widen: t -> t -> t * Cs.t.
Axiom getItv: t -> Lin.t -> itvT.
(* Now, useless !
Axiom assign: t -> assignT -> t * Cert.asgT.
*)
Axiom project: t -> PVar.t -> t * Cert.t.
Axiom rename: PVar.t -> PVar.t -> t -> t.
Axiom pr: t -> string.
