open NumC

module Cert : 
 sig 
  type frag_t = (int*QNum.t) list
  
  type cstrT =
  | Direct of frag_t
  | SplitEq of frag_t * frag_t
  
  val cstrT_rect :
    (frag_t -> 'a1) -> (frag_t -> frag_t -> 'a1) -> cstrT -> 'a1
  
  val cstrT_rec :
    (frag_t -> 'a1) -> (frag_t -> frag_t -> 'a1) -> cstrT -> 'a1
  
  type finalT =
  | Implies of (int*cstrT) list
  | Empty of frag_t
  
  val finalT_rect :
    ((int*cstrT) list -> 'a1) -> (frag_t -> 'a1) -> finalT -> 'a1
  
  val finalT_rec :
    ((int*cstrT) list -> 'a1) -> (frag_t -> 'a1) -> finalT -> 'a1
  
  type t =
  | Bind of int * cstrT * t
  | Final of finalT
  
  val t_rect :
    (int -> cstrT -> t -> 'a1 -> 'a1) -> (finalT -> 'a1) -> t -> 'a1
  
  val t_rec :
    (int -> cstrT -> t -> 'a1 -> 'a1) -> (finalT -> 'a1) -> t -> 'a1
  
  type joinEltT = { id : int; arg1 : cstrT; arg2 : cstrT }
  
  val joinEltT_rect : (int -> cstrT -> cstrT -> 'a1) -> joinEltT -> 'a1
  
  val joinEltT_rec : (int -> cstrT -> cstrT -> 'a1) -> joinEltT -> 'a1
  
  val id : joinEltT -> int
  
  val arg1 : joinEltT -> cstrT
  
  val arg2 : joinEltT -> cstrT
  
  type joinT = joinEltT list
  
  type asgT =
  | AsgInv of (int*t) list * t
  | AsgNInv of t * (int*t) list
  
  val asgT_rect :
    ((int*t) list -> t -> 'a1) -> (t -> (int*t) list -> 'a1) -> asgT -> 'a1
  
  val asgT_rec :
    ((int*t) list -> t -> 'a1) -> (t -> (int*t) list -> 'a1) -> asgT -> 'a1
  
  type meetT = { sh : int; meetCert : t }
  
  val meetT_rect : (int -> t -> 'a1) -> meetT -> 'a1
  
  val meetT_rec : (int -> t -> 'a1) -> meetT -> 'a1
  
  val sh : meetT -> int
  
  val meetCert : meetT -> t
 end

