open CertC
open CoqAddOn
open CstrC
open Datatypes
open List0
open NumC
open ProgVar
open String0

module Cs = 
 struct 
  type cT = { id : int; cstr : Cstr.t }
  
  (** val cT_rect : (int -> Cstr.t -> 'a1) -> cT -> 'a1 **)
  
  let cT_rect f c =
    let { id = x; cstr = x0 } = c in f x x0
  
  (** val cT_rec : (int -> Cstr.t -> 'a1) -> cT -> 'a1 **)
  
  let cT_rec f c =
    let { id = x; cstr = x0 } = c in f x x0
  
  (** val id : cT -> int **)
  
  let id x = x.id
  
  (** val cstr : cT -> Cstr.t **)
  
  let cstr x = x.cstr
  
  type t = cT list
  
  (** val cTpr : cT -> char list **)
  
  let cTpr c =
    sprintf
      ('{'::('i'::('d'::(' '::('='::(' '::('%'::('s'::(';'::(' '::('c'::('s'::('t'::('r'::(' '::('='::(' '::('%'::('s'::('}'::[]))))))))))))))))))))
      (((fun i -> CoqPr.stringTr (string_of_int i)) c.id)::((Cstr.pr c.cstr)::[]))
  
  (** val pr : t -> char list **)
  
  let pr cs =
    concat nl (map cTpr cs)
  
  (** val top : t **)
  
  let top =
    []
  
  (** val add : t -> int -> Cstr.t -> t **)
  
  let add l i c =
    { id = i; cstr = c }::l
  
  (** val get : t -> int -> cT option **)
  
  let rec get l n =
    match l with
    | [] -> None
    | c1::l1 -> if (=) n c1.id then Some c1 else get l1 n
  
  (** val acc : Cstr.t -> cT -> QNum.t -> Cstr.t **)
  
  let acc c1 c2 n =
    Cstr.add c1 (Cstr.mul n c2.cstr)
  
  (** val combineRec : t -> Cert.frag_t -> Cstr.t -> Cstr.t **)
  
  let rec combineRec l f c =
    match f with
    | [] -> c
    | p::f1 ->
      let n,coef = p in
      combineRec l f1
        (match get l n with
         | Some cn -> Cstr.add c (Cstr.mul coef cn.cstr)
         | None ->
           (fun l _ -> failwith (CoqPr.charListTr l))
             (append
               ('C'::('o'::('n'::('s'::('S'::('e'::('t'::('.'::('c'::('o'::('m'::('b'::('i'::('n'::('e'::('R'::('e'::('c'::(':'::[])))))))))))))))))))
               (append ((fun i -> CoqPr.stringTr (string_of_int i)) n)
                 (append ('?'::[]) (pr l)))) c)
  
  (** val combine : t -> Cert.frag_t -> Cstr.t **)
  
  let rec combine l = function
  | [] -> Cstr.top
  | p::f1 ->
    let n,coef = p in
    (match get l n with
     | Some cn -> combineRec l f1 (Cstr.mul coef cn.cstr)
     | None ->
       (fun l _ -> failwith (CoqPr.charListTr l))
         (append
           ('C'::('o'::('n'::('s'::('S'::('e'::('t'::('.'::('c'::('o'::('m'::('b'::('i'::('n'::('e'::(':'::[]))))))))))))))))
           (append ((fun i -> CoqPr.stringTr (string_of_int i)) n)
             (append ('?'::[]) (pr l)))) Cstr.top)
  
  (** val build1 : t -> Cert.cstrT -> Cstr.t **)
  
  let build1 l = function
  | Cert.Direct f -> combine l f
  | Cert.SplitEq (f1, f2) -> Cstr.merge (combine l f1) (combine l f2)
  
  (** val build : t -> (int*Cert.cstrT) list -> t **)
  
  let rec build l = function
  | [] -> []
  | p::cert0 ->
    let id0,c = p in
    { id = id0; cstr =
    (match c with
     | Cert.Direct f -> combine l f
     | Cert.SplitEq (f1, f2) -> Cstr.merge (combine l f1) (combine l f2)) }::
    (build l cert0)
  
  (** val chkSyn : t -> t -> bool **)
  
  let rec chkSyn l1 = function
  | [] -> true
  | c2::l2' ->
    (match get l1 c2.id with
     | Some c1 ->
       if Cstr.isIncl c1.cstr c2.cstr then chkSyn l1 l2' else false
     | None -> false)
  
  (** val chk : t -> t -> (int*Cert.cstrT) list -> bool **)
  
  let chk l1 l2 cert =
    chkSyn (build l1 cert) l2
  
  (** val checkEmpty : t -> Cert.frag_t -> bool **)
  
  let checkEmpty l f =
    Cstr.isContrad (combine l f)
  
  (** val bind1 : t -> int -> Cert.cstrT -> t **)
  
  let bind1 l i cert =
    add l i
      (match cert with
       | Cert.Direct f -> combine l f
       | Cert.SplitEq (f1, f2) -> Cstr.merge (combine l f1) (combine l f2))
  
  (** val bind : t -> Cert.t -> t*Cert.finalT **)
  
  let rec bind l = function
  | Cert.Bind (i, cert1, cert2) ->
    bind
      (add l i
        (match cert1 with
         | Cert.Direct f -> combine l f
         | Cert.SplitEq (f1, f2) -> Cstr.merge (combine l f1) (combine l f2)))
      cert2
  | Cert.Final cert1 -> l,cert1
  
  (** val chkIncl : t -> t -> Cert.t -> bool **)
  
  let chkIncl l1 l2 cert =
    let nl1,cert1 = bind l1 cert in
    (match cert1 with
     | Cert.Implies cert2 -> chk nl1 l2 cert2
     | Cert.Empty f -> false)
  
  (** val chkEmpty : t -> Cert.t -> bool **)
  
  let chkEmpty l cert =
    let nl1,cert1 = bind l cert in
    (match cert1 with
     | Cert.Implies l0 -> false
     | Cert.Empty cert2 -> checkEmpty nl1 cert2)
  
  (** val approx : t -> Cert.t -> t **)
  
  let approx l cert =
    let nl1,cert1 = bind l cert in
    (match cert1 with
     | Cert.Implies cert2 -> build nl1 cert2
     | Cert.Empty f ->
       (fun l _ -> failwith (CoqPr.charListTr l))
         ('C'::('o'::('n'::('s'::('S'::('e'::('t'::('.'::('a'::('p'::('p'::('r'::('o'::('x'::[]))))))))))))))
         top)
  
  (** val redAdd : t -> int -> Cstr.t -> Cert.t -> t **)
  
  let redAdd l i c cert =
    let nl1,cert1 = bind (add l i c) cert in
    (match cert1 with
     | Cert.Implies cert2 -> build nl1 cert2
     | Cert.Empty f ->
       (fun l _ -> failwith (CoqPr.charListTr l))
         ('C'::('o'::('n'::('s'::('S'::('e'::('t'::('.'::('a'::('p'::('p'::('r'::('o'::('x'::[]))))))))))))))
         top)
  
  (** val addp : t -> int -> Cstr.t -> Cert.t -> Cert.t -> t option **)
  
  let addp l i c fwd bwd =
    let l' = redAdd l i c fwd in
    if chkIncl l' ({ id = i; cstr = c }::l) bwd
    then Some l'
    else (fun l _ -> failwith (CoqPr.charListTr l))
           ('C'::('o'::('n'::('s'::('S'::('e'::('t'::('.'::('C'::('s'::('I'::('m'::('p'::('l'::('.'::('a'::('d'::('d'::('p'::[])))))))))))))))))))
           None
  
  (** val shift1 : int -> cT -> cT **)
  
  let shift1 sh0 c =
    { id = ((+) c.id sh0); cstr = c.cstr }
  
  (** val shift : int -> t -> t **)
  
  let shift sh0 l =
    map (shift1 sh0) l
  
  (** val meet : t -> t -> Cert.meetT -> t **)
  
  let meet l1 l2 cert =
    let l2' = shift cert.Cert.sh l2 in
    let nl1,cert1 = bind (app l1 l2') cert.Cert.meetCert in
    (match cert1 with
     | Cert.Implies cert2 -> build nl1 cert2
     | Cert.Empty f ->
       (fun l _ -> failwith (CoqPr.charListTr l))
         ('C'::('o'::('n'::('s'::('S'::('e'::('t'::('.'::('a'::('p'::('p'::('r'::('o'::('x'::[]))))))))))))))
         top)
  
  (** val meetEmpty : t -> t -> Cert.meetT -> bool **)
  
  let meetEmpty l1 l2 cert =
    let l2' = shift cert.Cert.sh l2 in
    chkEmpty (app l1 l2') cert.Cert.meetCert
  
  (** val choose : Cstr.t -> Cstr.t -> Cstr.t option **)
  
  let choose c1 c2 =
    if Cstr.isIncl c1 c2
    then Some c2
    else if Cstr.isIncl c2 c1 then Some c1 else None
  
  (** val jSplit : Cstr.t -> Cstr.t list **)
  
  let jSplit c =
    match Cstr.split c with
    | Some p -> let c1,c2 = p in c::(c1::(c2::[]))
    | None -> c::[]
  
  (** val jTry1 : Cstr.t -> Cstr.t list -> Cstr.t option **)
  
  let rec jTry1 c = function
  | [] -> None
  | c'::l' ->
    (match choose c c' with
     | Some c0 -> Some c0
     | None -> jTry1 c l')
  
  (** val jTryIneqs : Cstr.t list -> Cstr.t list -> Cstr.t option **)
  
  let rec jTryIneqs l1 l2 =
    match l1 with
    | [] -> None
    | c'::l' ->
      (match jTry1 c' l2 with
       | Some t0 -> Some t0
       | None -> jTryIneqs l' l2)
  
  (** val tryIneq : Cstr.t -> Cstr.t -> Cstr.t **)
  
  let tryIneq c1 c2 =
    match jTryIneqs (jSplit c1) (jSplit c2) with
    | Some c -> c
    | None ->
      (fun l _ -> failwith (CoqPr.charListTr l))
        ('C'::('o'::('n'::('s'::('S'::('e'::('t'::('.'::('t'::('r'::('y'::('I'::('n'::('e'::('q'::[])))))))))))))))
        Cstr.top
  
  (** val buildJoin1 : t -> t -> Cert.joinEltT -> Cstr.t **)
  
  let buildJoin1 l1 l2 cert =
    let c1 =
      match cert.Cert.arg1 with
      | Cert.Direct f -> combine l1 f
      | Cert.SplitEq (f1, f2) -> Cstr.merge (combine l1 f1) (combine l1 f2)
    in
    let c2 =
      match cert.Cert.arg2 with
      | Cert.Direct f -> combine l2 f
      | Cert.SplitEq (f1, f2) -> Cstr.merge (combine l2 f1) (combine l2 f2)
    in
    (match choose c1 c2 with
     | Some c -> c
     | None -> tryIneq c1 c2)
  
  (** val buildJoin : t -> t -> Cert.joinT -> t **)
  
  let rec buildJoin l1 l2 = function
  | [] -> []
  | h::cert1 ->
    { id = h.Cert.id; cstr = (buildJoin1 l1 l2 h) }::(buildJoin l1 l2 cert1)
  
  (** val isFree : PVar.t -> t -> bool **)
  
  let rec isFree x = function
  | [] -> true
  | c::cs' -> if Cstr.isFree x c.cstr then isFree x cs' else false
  
  (** val rename : PVar.t -> PVar.t -> t -> t **)
  
  let rec rename x y = function
  | [] -> []
  | c::cs' ->
    { id = c.id; cstr = (Cstr.rename x y c.cstr) }::(rename x y cs')
 end

