open CertC
open CoqAddOn
open CstrC
open Datatypes
open List0
open NumC
open ProgVar
open String0

module Cs : 
 sig 
  type cT = { id : int; cstr : Cstr.t }
  
  val cT_rect : (int -> Cstr.t -> 'a1) -> cT -> 'a1
  
  val cT_rec : (int -> Cstr.t -> 'a1) -> cT -> 'a1
  
  val id : cT -> int
  
  val cstr : cT -> Cstr.t
  
  type t = cT list
  
  val cTpr : cT -> char list
  
  val pr : t -> char list
  
  val top : t
  
  val add : t -> int -> Cstr.t -> t
  
  val get : t -> int -> cT option
  
  val acc : Cstr.t -> cT -> QNum.t -> Cstr.t
  
  val combineRec : t -> Cert.frag_t -> Cstr.t -> Cstr.t
  
  val combine : t -> Cert.frag_t -> Cstr.t
  
  val build1 : t -> Cert.cstrT -> Cstr.t
  
  val build : t -> (int*Cert.cstrT) list -> t
  
  val chkSyn : t -> t -> bool
  
  val chk : t -> t -> (int*Cert.cstrT) list -> bool
  
  val checkEmpty : t -> Cert.frag_t -> bool
  
  val bind1 : t -> int -> Cert.cstrT -> t
  
  val bind : t -> Cert.t -> t*Cert.finalT
  
  val chkIncl : t -> t -> Cert.t -> bool
  
  val chkEmpty : t -> Cert.t -> bool
  
  val approx : t -> Cert.t -> t
  
  val redAdd : t -> int -> Cstr.t -> Cert.t -> t
  
  val addp : t -> int -> Cstr.t -> Cert.t -> Cert.t -> t option
  
  val shift1 : int -> cT -> cT
  
  val shift : int -> t -> t
  
  val meet : t -> t -> Cert.meetT -> t
  
  val meetEmpty : t -> t -> Cert.meetT -> bool
  
  val choose : Cstr.t -> Cstr.t -> Cstr.t option
  
  val jSplit : Cstr.t -> Cstr.t list
  
  val jTry1 : Cstr.t -> Cstr.t list -> Cstr.t option
  
  val jTryIneqs : Cstr.t list -> Cstr.t list -> Cstr.t option
  
  val tryIneq : Cstr.t -> Cstr.t -> Cstr.t
  
  val buildJoin1 : t -> t -> Cert.joinEltT -> Cstr.t
  
  val buildJoin : t -> t -> Cert.joinT -> t
  
  val isFree : PVar.t -> t -> bool
  
  val rename : PVar.t -> PVar.t -> t -> t
 end

