open LinTerm
open NumC
open ProgVar
open String0

type cmpT =
| Eq
| Le
| Lt

module Cstr : 
 sig 
  type tInd = { coefs : Lin.t; typ : cmpT; cst : QNum.t }
  
  val tInd_rect : (Lin.t -> cmpT -> QNum.t -> 'a1) -> tInd -> 'a1
  
  val tInd_rec : (Lin.t -> cmpT -> QNum.t -> 'a1) -> tInd -> 'a1
  
  val coefs : tInd -> Lin.t
  
  val typ : tInd -> cmpT
  
  val cst : tInd -> QNum.t
  
  type t = tInd
  
  val top : tInd
  
  val isInclEq : t -> t -> bool
  
  val isInclLt : t -> t -> bool
  
  val isInclLe : t -> t -> bool
  
  val isIncl : t -> t -> bool
  
  val isContrad : t -> bool
  
  val cmpAdd : cmpT -> cmpT -> cmpT
  
  val add : t -> t -> t
  
  val mulSimpl : t -> QNum.t -> t
  
  val mul : QNum.t -> t -> t
  
  val merge : tInd -> tInd -> t
  
  val split : t -> (t*t) option
  
  val isFree : PVar.t -> t -> bool
  
  val rename : PVar.t -> PVar.t -> tInd -> t
  
  val cmpPr : cmpT -> char list
  
  val pr : t -> char list
  
  val upperToCstr : Lin.t -> QNum.t -> t
  
  val upperOrEqualsToCstr : Lin.t -> QNum.t -> t
  
  val lowerToCstr : Lin.t -> QNum.t -> t
  
  val lowerOrEqualsToCstr : Lin.t -> QNum.t -> t
 end

