open BinNums
open Datatypes
open OrderedTypeEx
open Peano

val append : positive -> positive -> positive

module PositiveMap : 
 sig 
  module E : 
   sig 
    type t = positive
    
    val compare : t -> t -> positive OrderedType.coq_Compare
    
    val eq_dec : positive -> positive -> bool
   end
  
  module ME : 
   sig 
    module MO : 
     sig 
      module TO : 
       sig 
        type t = positive
       end
      
      module IsTO : 
       sig 
        
       end
      
      module OrderTac : 
       sig 
        
       end
      
      val eq_dec : positive -> positive -> bool
      
      val lt_dec : positive -> positive -> bool
      
      val eqb : positive -> positive -> bool
     end
   end
  
  type key = positive
  
  type 'a tree =
  | Leaf
  | Node of 'a tree * 'a option * 'a tree
  
  type 'a t = 'a tree
  
  val empty : 'a1 t
  
  val is_empty : 'a1 t -> bool
  
  val find : positive -> 'a1 t -> 'a1 option
  
  val mem : positive -> 'a1 t -> bool
  
  val add : positive -> 'a1 -> 'a1 t -> 'a1 t
  
  val remove : positive -> 'a1 t -> 'a1 t
  
  val xelements : 'a1 t -> positive -> (positive*'a1) list
  
  val elements : 'a1 t -> (positive*'a1) list
  
  val cardinal : 'a1 t -> nat
  
  val xfind : positive -> positive -> 'a1 t -> 'a1 option
  
  val xmapi : (positive -> 'a1 -> 'a2) -> 'a1 t -> positive -> 'a2 t
  
  val mapi : (positive -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t
  
  val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t
  
  val xmap2_l : ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a3 t
  
  val xmap2_r : ('a1 option -> 'a2 option -> 'a3 option) -> 'a2 t -> 'a3 t
  
  val _map2 :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t
  
  val map2 :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t
  
  val xfoldi :
    (positive -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> positive -> 'a2
  
  val fold : (positive -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2
  
  val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool
 end

