open Datatypes
open NumC
open Specif
open String0

type __ = Obj.t

module type ItvSig = 
 functor (N:NumSig) ->
 sig 
  type t 
  
  val mk1Dep : N.t -> t
  
  val mk1 : N.t -> t
  
  val addDep : t -> t -> t
  
  val add : t -> t -> t
  
  val negDep : t -> t
  
  val neg : t -> t
  
  val mulcDep : t -> N.t -> t
  
  val mulc : t -> N.t -> t
  
  val pr : t -> char list
 end

module StdItv : 
 functor (N:NumSig) ->
 sig 
  type bndT =
  | Infty
  | Open of N.t
  | Closed of N.t
  
  val bndT_rect : 'a1 -> (N.t -> 'a1) -> (N.t -> 'a1) -> bndT -> 'a1
  
  val bndT_rec : 'a1 -> (N.t -> 'a1) -> (N.t -> 'a1) -> bndT -> 'a1
  
  type tInd =
  | Bot
  | NotBot of bndT * bndT
  
  val tInd_rect : 'a1 -> (bndT -> bndT -> __ -> 'a1) -> tInd -> 'a1
  
  val tInd_rec : 'a1 -> (bndT -> bndT -> __ -> 'a1) -> tInd -> 'a1
  
  type t = tInd
  
  val mk : bndT -> bndT -> t
  
  val mk1Dep : N.t -> t
  
  val mk1 : N.t -> t
  
  val bndAdd : bndT -> bndT -> bndT
  
  val addDep : t -> t -> t
  
  val add : t -> t -> t
  
  val bndNeg : bndT -> bndT
  
  val negDep : t -> t
  
  val neg : t -> t
  
  val bndMulc : bndT -> N.t -> bndT
  
  val mulcPos : t -> N.t -> t
  
  val mulcZ : t -> t
  
  val mulcDep : t -> N.t -> t
  
  val mulc : t -> N.t -> t
  
  val pr : t -> char list
 end

module QItv : 
 sig 
  type bndT =
  | Infty
  | Open of QNum.t
  | Closed of QNum.t
  
  val bndT_rect : 'a1 -> (QNum.t -> 'a1) -> (QNum.t -> 'a1) -> bndT -> 'a1
  
  val bndT_rec : 'a1 -> (QNum.t -> 'a1) -> (QNum.t -> 'a1) -> bndT -> 'a1
  
  type tInd =
  | Bot
  | NotBot of bndT * bndT
  
  val tInd_rect : 'a1 -> (bndT -> bndT -> __ -> 'a1) -> tInd -> 'a1
  
  val tInd_rec : 'a1 -> (bndT -> bndT -> __ -> 'a1) -> tInd -> 'a1
  
  type t = tInd
  
  val mk : bndT -> bndT -> t
  
  val mk1Dep : QNum.t -> t
  
  val mk1 : QNum.t -> t
  
  val bndAdd : bndT -> bndT -> bndT
  
  val addDep : t -> t -> t
  
  val add : t -> t -> t
  
  val bndNeg : bndT -> bndT
  
  val negDep : t -> t
  
  val neg : t -> t
  
  val bndMulc : bndT -> QNum.t -> bndT
  
  val mulcPos : t -> QNum.t -> t
  
  val mulcZ : t -> t
  
  val mulcDep : t -> QNum.t -> t
  
  val mulc : t -> QNum.t -> t
  
  val pr : t -> char list
  
  val shiftDep : t -> QNum.t -> t
  
  val shift : t -> QNum.t -> t
 end

module ZItv : 
 sig 
  type bndT =
  | Infty
  | Open of ZNum.t
  | Closed of ZNum.t
  
  val bndT_rect : 'a1 -> (ZNum.t -> 'a1) -> (ZNum.t -> 'a1) -> bndT -> 'a1
  
  val bndT_rec : 'a1 -> (ZNum.t -> 'a1) -> (ZNum.t -> 'a1) -> bndT -> 'a1
  
  type tInd =
  | Bot
  | NotBot of bndT * bndT
  
  val tInd_rect : 'a1 -> (bndT -> bndT -> __ -> 'a1) -> tInd -> 'a1
  
  val tInd_rec : 'a1 -> (bndT -> bndT -> __ -> 'a1) -> tInd -> 'a1
  
  type t = tInd
  
  val mk : bndT -> bndT -> t
  
  val mk1Dep : ZNum.t -> t
  
  val mk1 : ZNum.t -> t
  
  val bndAdd : bndT -> bndT -> bndT
  
  val addDep : t -> t -> t
  
  val add : t -> t -> t
  
  val bndNeg : bndT -> bndT
  
  val negDep : t -> t
  
  val neg : t -> t
  
  val bndMulc : bndT -> ZNum.t -> bndT
  
  val mulcPos : t -> ZNum.t -> t
  
  val mulcZ : t -> t
  
  val mulcDep : t -> ZNum.t -> t
  
  val mulc : t -> ZNum.t -> t
  
  val pr : t -> char list
  
  val tightenL : QItv.bndT -> bndT
  
  val tightenU : QItv.bndT -> bndT
  
  val fromQItv : QItv.t -> t
 end

