open Datatypes
open FMapPositive
open List0
open NumC
open PositiveMapAddOn
open ProgVar
open String0

module Lin : 
 sig 
  type t = QNum.t PositiveMap.t
  
  val absEval : (PVar.t*QNum.t) list -> QNum.t Mem.t -> QNum.t
  
  val eval : t -> QNum.t Mem.t -> QNum.t
  
  val nil : t
  
  val single : PVar.t -> QNum.t -> t
  
  val neg : t -> QNum.t PositiveMap.t
  
  val mul : QNum.t -> t -> t
  
  val coq_QNum_eqb : QNum.t -> QNum.t -> bool
  
  val isEq : t -> t -> bool
  
  val add : t -> t -> t
  
  val isFree : PVar.t -> t -> bool
  
  val rename : PVar.t -> PVar.t -> t -> t
  
  val fmtAux : char list list -> char list -> char list
  
  val fmt : char list list -> char list
  
  val pairPr : (PVar.t*QNum.t) -> char list
  
  val pr : t -> char list
  
  type exportT = (PVar.t*QNum.t) list
  
  val export : t -> exportT
  
  val import : exportT -> t
 end

