open BinNums
open BinPos
open Bool
open Datatypes
open Peano

module PositiveOrderedTypeBits : 
 sig 
  type t = positive
  
  val eqb : positive -> positive -> bool
  
  val eq_dec : positive -> positive -> bool
  
  val compare : positive -> positive -> comparison
 end

module PositiveSet : 
 sig 
  module E : 
   sig 
    type t = positive
    
    val eqb : positive -> positive -> bool
    
    val eq_dec : positive -> positive -> bool
    
    val compare : positive -> positive -> comparison
   end
  
  type elt = positive
  
  type tree =
  | Leaf
  | Node of tree * bool * tree
  
  type t = tree
  
  val empty : tree
  
  val is_empty : t -> bool
  
  val mem : positive -> t -> bool
  
  val add : positive -> t -> t
  
  val singleton : positive -> t
  
  val node : tree -> bool -> tree -> tree
  
  val remove : positive -> t -> t
  
  val union : t -> t -> t
  
  val inter : t -> t -> tree
  
  val diff : t -> t -> tree
  
  val equal : t -> t -> bool
  
  val subset : t -> t -> bool
  
  val rev_append : positive -> positive -> positive
  
  val rev : positive -> positive
  
  val xfold : (positive -> 'a1 -> 'a1) -> t -> 'a1 -> positive -> 'a1
  
  val fold : (positive -> 'a1 -> 'a1) -> t -> 'a1 -> 'a1
  
  val xforall : (positive -> bool) -> t -> positive -> bool
  
  val for_all : (positive -> bool) -> t -> bool
  
  val xexists : (positive -> bool) -> t -> positive -> bool
  
  val exists_ : (positive -> bool) -> t -> bool
  
  val xfilter : (positive -> bool) -> t -> positive -> tree
  
  val filter : (positive -> bool) -> t -> tree
  
  val xpartition : (positive -> bool) -> t -> positive -> tree*tree
  
  val partition : (positive -> bool) -> t -> tree*tree
  
  val xelements : t -> positive -> positive list -> positive list
  
  val elements : t -> positive list
  
  val cardinal : t -> nat
  
  val omap : (elt -> elt) -> elt option -> elt option
  
  val choose : t -> positive option
  
  val min_elt : t -> positive option
  
  val max_elt : t -> positive option
  
  val compare_bool : bool -> bool -> comparison
  
  val compare : t -> t -> comparison
  
  val eq_dec : t -> t -> bool
 end

