open BinInt
open BinNums
open CoqAddOn
open QArith_base
open Qcanon
open Qround
open Specif
open ZArith_dec

module type NumSig = 
 sig 
  type t 
  
  val z : t
  
  val u : t
  
  val eqDec : t -> t -> bool
  
  val ltLeDec : t -> t -> bool
  
  val dec : t -> t -> bool sumor
  
  val add : t -> t -> t
  
  val mul : t -> t -> t
  
  val neg : t -> t
  
  val pr : t -> char list
  
  val prRaw : t -> char list
 end

module QNum : 
 sig 
  type t = coq_Qc
  
  val z : t
  
  val u : t
  
  val add : t -> t -> t
  
  val sub : t -> t -> t
  
  val mul : t -> t -> t
  
  val div : t -> t -> t
  
  val neg : t -> t
  
  val inv : t -> t
  
  val eqDec : t -> t -> bool
  
  val ltLeDec : t -> t -> bool
  
  val dec : t -> t -> bool sumor
  
  val pr : t -> char list
  
  val prRaw : t -> char list
 end

module ZNum : 
 sig 
  type t = coq_Z
  
  val z : t
  
  val u : t
  
  val eqDec : t -> t -> bool
  
  val ltLeDec : t -> t -> bool
  
  val dec : t -> t -> bool sumor
  
  val add : t -> t -> t
  
  val mul : t -> t -> t
  
  val neg : t -> t
  
  val pr : t -> char list
  
  val prRaw : t -> char list
 end

module ZtoQ : 
 sig 
  val ofZ : ZNum.t -> QNum.t
  
  val floor : QNum.t -> ZNum.t
  
  val ceil : QNum.t -> ZNum.t
 end

