open BinNums
open BinPos
open Datatypes

module PositiveOrderedTypeBits = 
 struct 
  type t = positive
  
  (** val compare : t -> t -> positive OrderedType.coq_Compare **)
  
  let rec compare p y =
    match p with
    | Coq_xI p0 ->
      (match y with
       | Coq_xI y0 -> compare p0 y0
       | _ -> OrderedType.GT)
    | Coq_xO p0 ->
      (match y with
       | Coq_xO y0 -> compare p0 y0
       | _ -> OrderedType.LT)
    | Coq_xH ->
      (match y with
       | Coq_xI y0 -> OrderedType.LT
       | Coq_xO y0 -> OrderedType.GT
       | Coq_xH -> OrderedType.EQ)
  
  (** val eq_dec : positive -> positive -> bool **)
  
  let eq_dec x y =
    match Pos.compare x y with
    | Eq -> true
    | _ -> false
 end

