open CertC
open NumC

type inclT =
| NotIncl
| Incl of Cert.t

(** val inclT_rect : 'a1 -> (Cert.t -> 'a1) -> inclT -> 'a1 **)

let inclT_rect f f0 = function
| NotIncl -> f
| Incl x -> f0 x

(** val inclT_rec : 'a1 -> (Cert.t -> 'a1) -> inclT -> 'a1 **)

let inclT_rec f f0 = function
| NotIncl -> f
| Incl x -> f0 x

type bndT =
| Infty
| Open of QNum.t * Cert.frag_t
| Closed of QNum.t * Cert.frag_t

(** val bndT_rect :
    'a1 -> (QNum.t -> Cert.frag_t -> 'a1) -> (QNum.t -> Cert.frag_t -> 'a1)
    -> bndT -> 'a1 **)

let bndT_rect f f0 f1 = function
| Infty -> f
| Open (x, x0) -> f0 x x0
| Closed (x, x0) -> f1 x x0

(** val bndT_rec :
    'a1 -> (QNum.t -> Cert.frag_t -> 'a1) -> (QNum.t -> Cert.frag_t -> 'a1)
    -> bndT -> 'a1 **)

let bndT_rec f f0 f1 = function
| Infty -> f
| Open (x, x0) -> f0 x x0
| Closed (x, x0) -> f1 x x0

type itvT = { low : bndT; up : bndT }

(** val itvT_rect : (bndT -> bndT -> 'a1) -> itvT -> 'a1 **)

let itvT_rect f i =
  let { low = x; up = x0 } = i in f x x0

(** val itvT_rec : (bndT -> bndT -> 'a1) -> itvT -> 'a1 **)

let itvT_rec f i =
  let { low = x; up = x0 } = i in f x x0

(** val low : itvT -> bndT **)

let low x = x.low

(** val up : itvT -> bndT **)

let up x = x.up

type addPrecT =
| Added of Pol.t * (Cert.t*Cert.t)
| Contrad of Cert.t

(** val addPrecT_rect :
    (Pol.t -> (Cert.t*Cert.t) -> 'a1) -> (Cert.t -> 'a1) -> addPrecT -> 'a1 **)

let addPrecT_rect f f0 = function
| Added (x, x0) -> f x x0
| Contrad x -> f0 x

(** val addPrecT_rec :
    (Pol.t -> (Cert.t*Cert.t) -> 'a1) -> (Cert.t -> 'a1) -> addPrecT -> 'a1 **)

let addPrecT_rec f f0 = function
| Added (x, x0) -> f x x0
| Contrad x -> f0 x

