open CertC
open NumC

type inclT =
| NotIncl
| Incl of Cert.t

val inclT_rect : 'a1 -> (Cert.t -> 'a1) -> inclT -> 'a1

val inclT_rec : 'a1 -> (Cert.t -> 'a1) -> inclT -> 'a1

type bndT =
| Infty
| Open of QNum.t * Cert.frag_t
| Closed of QNum.t * Cert.frag_t

val bndT_rect :
  'a1 -> (QNum.t -> Cert.frag_t -> 'a1) -> (QNum.t -> Cert.frag_t -> 'a1) ->
  bndT -> 'a1

val bndT_rec :
  'a1 -> (QNum.t -> Cert.frag_t -> 'a1) -> (QNum.t -> Cert.frag_t -> 'a1) ->
  bndT -> 'a1

type itvT = { low : bndT; up : bndT }

val itvT_rect : (bndT -> bndT -> 'a1) -> itvT -> 'a1

val itvT_rec : (bndT -> bndT -> 'a1) -> itvT -> 'a1

val low : itvT -> bndT

val up : itvT -> bndT

type addPrecT =
| Added of Pol.t * (Cert.t*Cert.t)
| Contrad of Cert.t

val addPrecT_rect :
  (Pol.t -> (Cert.t*Cert.t) -> 'a1) -> (Cert.t -> 'a1) -> addPrecT -> 'a1

val addPrecT_rec :
  (Pol.t -> (Cert.t*Cert.t) -> 'a1) -> (Cert.t -> 'a1) -> addPrecT -> 'a1

