COQ=.
FSHARP=.
LIB=../lib
DLL=VERIMAG_Polyhedra_Library.dll

MLFILES=`sed -e s/\.cmo/.ml/g ../obj/vpl_cma.mlist`

files=`cd $LIB; echo *.ml`
echo $files

for file in $files;
do
  if [ $file != Num.ml ] ;
  then 
    sed -e 's/\.Shadow\././' -e 's/List\.sort/List.sortWith/' -e 's/List\.for_all/List.forall/' -e 's/Not_found/:? System.Collections.Generic.KeyNotFoundException/g' $LIB/$file > $FSHARP/$file
    # -e "s/String\.create/(fun x -> String.make x ' ')/g" 
  fi
done

cp --remove-destination -s ../extract/*.ml ../extract/*.mli .

patch -p1 < fsharp.patch

fsharpc -a -r FSharp.PowerPack.Compatibility.dll -r FSharp.PowerPack.dll --mlcompatibility $MLFILES -o $DLL

mkdir test

TEST=../test
TESTMLFILES="T.ml Basis_t.ml Cert_t.ml Cstr_t.ml EqSet_t.ml IneqSet_t.ml Num_t.ml Opt_t.ml Pol_t.ml Rtree_t.ml Splx_t.ml Val_t.ml Var_t.ml Vec_t.ml Z_t.ml Glue_t.ml Support_t.ml PolC_t.ml PolZ_t.ml CoqAddOn_t.ml CoqPr_t.ml Coq_t.ml All_t.ml"

FSHARPTEST=$FSHARP/test
CONVERTEDTESTMLFILES=""
for file in $TESTMLFILES;
do
  sed -e 's/List.sort/List.sortWith/' -e 's/List\.for_all/List.forall/' -e 's/Not_found/:? System.Collections.Generic.KeyNotFoundException/g' $TEST/$file > $FSHARPTEST/$file
  CONVERTEDTESTMLFILES="$CONVERTEDTESTMLFILES $FSHARPTEST/$file"
done

fsharpc --mlcompatibility -r FSharp.PowerPack.Compatibility.dll -r $DLL $CONVERTEDTESTMLFILES -o test.exe
