rule token = parse
	| ' ' | '\t'	{token lexbuf}
	| '\n'	{CstrParser.EOL}
	| '('	{CstrParser.LPAREN}
	| ')'	{CstrParser.RPAREN}
	| '-'? ['0' - '9']+ as i	{CstrParser.INT(i)}
	| ['_' 'a' - 'z']['_' 'a' - 'z' 'A' - 'Z']* as v	{CstrParser.VAR(v)}
	| "<="	{CstrParser.CMP(CmpExt.LE)}
	| ">="	{CstrParser.CMP(CmpExt.GE)}
	| '<'	{CstrParser.CMP(CmpExt.LT)}
	| '>'	{CstrParser.CMP(CmpExt.GT)}
	| '='	{CstrParser.CMP(CmpExt.EQ)}
	| '+'	{CstrParser.ADD}
	| '-' {CstrParser.SUB}
	| '/'	{CstrParser.DIV}
	| '*' | '.'	{CstrParser.MUL}
	| eof {CstrParser.EOL}
