%token <string> INT
%token <string> VAR
%token <CmpExt.t> CMP
%token EOL LPAREN RPAREN
%token ADD SUB MUL DIV
%start main
%type <string> main
%%
main: cons EOL	{$1}
;
cons: aff CMP aff	{
	let (e, c) = Build.buildCons Env.nil $1 $2 $3 in
	Cstr.pr (Env.getBasis e) c
}
;
aff:
	| mono	{$1}
	| aff ADD mono	{Build.merge $1 $3}
	| aff SUB mono	{Build.merge $1 (Build.negate $3)}
;
mono:
	| num	{Build.create Build.constant $1}
	| VAR	{Build.create $1 Num.u}
	| num MUL VAR	{Build.create $3 $1}
;
num:
	| integer	{Num.mk1 $1}
	| LPAREN integer DIV integer RPAREN	{Num.mk $4 $2}
;
integer: INT {int_of_string $1}
;