module M = Map.Make (String)

type t = {basis: Basis.t; alloc: Var.t M.t}

let getBasis: t -> Basis.t = fun e -> e.basis

let nil: t = {basis = Basis.nil; alloc = M.empty}

let get: t -> string -> t * Var.t = fun e str ->
	if M.mem str e.alloc then
		(e, M.find str e.alloc)
	else
		let (x, b) = Basis.add e.basis str in
		({basis = b; alloc = M.add str x e.alloc}, x)
