let strTrTcs: (string * char list * string) list
= [
	"empty", [], "";
	"one", ['a'], "a";
	"str0", ['a'; 'b'; 'c'; 'd'], "abcd"
]

(* CoqPr.charListTr *)
let charListTrTs: T.testT
=	let chk (nm, l, s): T.stateT -> T.stateT
	= fun st ->
		let s' = CoqPr.charListTr l in
		if String.compare s s' = 0
		then T.succeed st
		else T.fail nm s' st
	in
	T.suite "charListTr" (List.map chk strTrTcs)

(* CoqPr.stringTr *)
let stringTrTs: T.testT
=	let chk (nm, l, s): T.stateT -> T.stateT
	= fun st ->
		let l' = CoqPr.stringTr s in
		if l = l'
		then T.succeed st
		else
			let e = String.concat " " (List.map (String.make 1) l') in
			T.fail nm e st
	in
	T.suite "stringTr" (List.map chk strTrTcs)

let ts: T.testT
= T.suite "CoqPr" [charListTrTs; stringTrTs]
