let [x; y] = T.pathGen 2

let varPr: Var.t -> string
= fun _x -> List.assoc _x [x, "x"; y, "y"]

let mkc t v c =
    Cstr.mk t (List.map (function (i, x) -> (Num.mk1 i, x)) v) (Num.mk1 c)

let eq = mkc Cstr.Eq
let le = mkc Cstr.Le
let lt = mkc Cstr.Lt

let mkc' t a b = Support.cToCstrC (mkc t a b)
let eq' = mkc' Cstr.Eq
let le' = mkc' Cstr.Le
let lt' = mkc' Cstr.Lt

let p (l: Cstr.t list): PolC.PolLinQ.t =
    match Pol.mk l with
    | None -> None
    | Some poly -> Glue.pToPolC poly

(* old: PolC.isInclCstr . Now: PolC.CstrPol.require *)
let isInclCstr: T.testT
=	let chk (nm, r, c, p): T.stateT -> T.stateT
	= fun st ->
		if PolC.CstrPol.require c (Obj.magic p)  (* needed because of Coq extraction on modules ! *)
		then (
			if r
			then T.succeed st
			else T.fail nm "unexpected inclusion" st
		) else (
			if r
			then T.fail nm "no inclusion" st
			else T.succeed st
                )
	in
	let tcs: (string * bool * CstrC.Cstr.t * PolC.PolLinQ.t) list
	= [
	"triv0", true, le' [1, x] 2, p [le [1, x] 2];
	"triv1", true, eq' [1, x] 2, p [eq [1, x] 2];
	"triv2", true, eq' [-1, x; 1, y] 0, p [eq [1, x; -1, y] 0];
	"comb0", true, le' [1, x; 2, y] 3, p [
		le [1, x] 1;
		le [1, y] 1];
	"eq0", true, eq' [1, y] 2, p [
		le [1, y] 2;
		le [-1, x] (-3);
		le [1, x; -1, y] 1];

	"trivf0", false, le' [1, x] 1, p [eq [1, x] 3]
	] in
	T.suite "isInclCstr" (List.map chk tcs)

let ts: T.testT
= T.suite "PolC" [isInclCstr] ;;
